/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tm_p.h"
#include "function.h"
#include "expr.h"
#include "optabs.h"
#include "real.h"
#include "dfp.h"
#include "flags.h"
#include "output.h"
#include "insn-config.h"
#include "hard-reg-set.h"
#include "recog.h"
#include "resource.h"
#include "reload.h"
#include "toplev.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "basic-block.h"
#include "integrate.h"

#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)

/* ../../gcc/config/avr/avr.md:538 */
rtx
gen_addqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:754 */
rtx
gen_addsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:785 */
rtx
gen_subqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:796 */
rtx
gen_subhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:818 */
rtx
gen_subsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:886 */
rtx
gen_mulqihi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	gen_rtx_SIGN_EXTEND (HImode,
	operand1),
	gen_rtx_SIGN_EXTEND (HImode,
	operand2)));
}

/* ../../gcc/config/avr/avr.md:897 */
rtx
gen_umulqihi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1),
	gen_rtx_ZERO_EXTEND (HImode,
	operand2)));
}

/* ../../gcc/config/avr/avr.md:1118 */
rtx
gen_andqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1129 */
rtx
gen_andhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/avr/avr.md:1160 */
rtx
gen_andsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1199 */
rtx
gen_iorqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1210 */
rtx
gen_iorhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1246 */
rtx
gen_iorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1293 */
rtx
gen_xorqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1302 */
rtx
gen_xorhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1312 */
rtx
gen_xorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1327 */
rtx
gen_ashlqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1336 */
rtx
gen_ashlhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1345 */
rtx
gen_ashlsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1401 */
rtx
gen_ashrqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1410 */
rtx
gen_ashrhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1419 */
rtx
gen_ashrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1475 */
rtx
gen_lshrqi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (QImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1484 */
rtx
gen_lshrhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (HImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1493 */
rtx
gen_lshrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:1549 */
rtx
gen_absqi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ABS (QImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1559 */
rtx
gen_abssf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ABS (SFmode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1572 */
rtx
gen_negqi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (QImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1580 */
rtx
gen_neghi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (HImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1591 */
rtx
gen_negsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1607 */
rtx
gen_negsf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (SFmode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1620 */
rtx
gen_one_cmplqi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NOT (QImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1628 */
rtx
gen_one_cmplhi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NOT (HImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1637 */
rtx
gen_one_cmplsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NOT (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1651 */
rtx
gen_extendqihi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (HImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1661 */
rtx
gen_extendqisi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1671 */
rtx
gen_extendhisi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1688 */
rtx
gen_zero_extendqihi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1703 */
rtx
gen_zero_extendqisi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1718 */
rtx
gen_zero_extendhisi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1733 */
rtx
gen_zero_extendqidi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1748 */
rtx
gen_zero_extendhidi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1763 */
rtx
gen_zero_extendsidi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1781 */
rtx
gen_tstqi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ../../gcc/config/avr/avr.md:1797 */
rtx
gen_tsthi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ../../gcc/config/avr/avr.md:1814 */
rtx
gen_tstsi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ../../gcc/config/avr/avr.md:1834 */
rtx
gen_cmpqi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1));
}

/* ../../gcc/config/avr/avr.md:1855 */
rtx
gen_cmphi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/avr/avr.md:1900 */
rtx
gen_cmpsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/avr/avr.md:2200 */
rtx
gen_branch (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand1), VOIDmode,
		cc0_rtx,
		const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2213 */
rtx
gen_difficult_branch (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand1), VOIDmode,
		cc0_rtx,
		const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2228 */
rtx
gen_rvbranch (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand1), VOIDmode,
		cc0_rtx,
		const0_rtx),
	pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0)));
}

/* ../../gcc/config/avr/avr.md:2241 */
rtx
gen_difficult_rvbranch (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand1), VOIDmode,
		cc0_rtx,
		const0_rtx),
	pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0)));
}

/* ../../gcc/config/avr/avr.md:2257 */
rtx
gen_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0));
}

/* ../../gcc/config/avr/avr.md:2296 */
rtx
gen_call_insn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (HImode,
	operand0),
	operand1);
}

/* ../../gcc/config/avr/avr.md:2332 */
rtx
gen_call_value_insn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (HImode,
	operand1),
	operand2));
}

/* ../../gcc/config/avr/avr.md:2369 */
rtx
gen_nop (void)
{
  return const0_rtx;
}

/* ../../gcc/config/avr/avr.md:2377 */
rtx
gen_indirect_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	operand0);
}

/* ../../gcc/config/avr/avr.md:2475 */
rtx
gen_sez (void)
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	const0_rtx);
}

/* ../../gcc/config/avr/avr.md:2728 */
rtx
gen_popqi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MEM (QImode,
	gen_rtx_POST_INC (VOIDmode,
	gen_rtx_REG (HImode,
	32))));
}

/* ../../gcc/config/avr/avr.md:2736 */
rtx
gen_pophi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MEM (HImode,
	gen_rtx_POST_INC (VOIDmode,
	gen_rtx_REG (HImode,
	32))));
}

/* ../../gcc/config/avr/avr.md:2745 */
rtx
gen_enable_interrupt (void)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	2);
}

/* ../../gcc/config/avr/avr.md:2754 */
rtx
gen_disable_interrupt (void)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	3);
}

/* ../../gcc/config/avr/avr.md:2763 */
rtx
gen_call_prologue_saves (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_UNSPEC_VOLATILE (HImode,
	gen_rtvec (1,
		const0_rtx),
	0),
		operand0,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	32),
	gen_rtx_MINUS (HImode,
	gen_rtx_REG (HImode,
	32),
	operand1)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (HImode,
	26)),
		gen_hard_reg_clobber (HImode, 30)));
}

/* ../../gcc/config/avr/avr.md:2784 */
rtx
gen_epilogue_restores (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (4,
		gen_rtx_UNSPEC_VOLATILE (QImode,
	gen_rtvec (1,
		const0_rtx),
	1),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	28),
	gen_rtx_PLUS (HImode,
	gen_rtx_REG (HImode,
	28),
	operand0)),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	32),
	gen_rtx_REG (HImode,
	28)),
		gen_hard_reg_clobber (QImode, 30)));
}

/* ../../gcc/config/avr/avr.md:2802 */
rtx
gen_return (void)
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ../../gcc/config/avr/avr.md:2809 */
rtx
gen_return_from_epilogue (void)
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ../../gcc/config/avr/avr.md:2819 */
rtx
gen_return_from_interrupt_epilogue (void)
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ../../gcc/config/avr/avr.md:2829 */
rtx
gen_return_from_naked_epilogue (void)
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ../../gcc/config/avr/avr.md:162 */
rtx
gen_movqi (rtx operand0,
	rtx operand1)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#line 166 "../../gcc/config/avr/avr.md"
/* One of the ops has to be in a register.  */
   if (!register_operand(operand0, QImode)
       && ! (register_operand(operand1, QImode) || const0_rtx == operand1))
       operands[1] = copy_to_mode_reg(QImode, operand1);
  
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:194 */
extern rtx gen_peephole2_129 (rtx, rtx *);
rtx
gen_peephole2_129 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[2] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 203 "../../gcc/config/avr/avr.md"
if (!avr_peep2_scratch_safe (operands[2]))
     FAIL;
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:209 */
rtx
gen_movhi (rtx operand0,
	rtx operand1)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#line 213 "../../gcc/config/avr/avr.md"

{
   /* One of the ops has to be in a register.  */
  if (!register_operand(operand0, HImode)
      && !(register_operand(operand1, HImode) || const0_rtx == operands[1]))
    {
      operands[1] = copy_to_mode_reg(HImode, operand1);
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:232 */
extern rtx gen_peephole2_131 (rtx, rtx *);
rtx
gen_peephole2_131 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[2] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 240 "../../gcc/config/avr/avr.md"
if (!avr_peep2_scratch_safe (operands[2]))
     FAIL;
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:262 */
extern rtx gen_peephole2_132 (rtx, rtx *);
rtx
gen_peephole2_132 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 271 "../../gcc/config/avr/avr.md"
{
    operands[4] = gen_rtx_REG (HImode, REGNO (operands[0]));
    operands[5] = gen_rtx_REG (HImode, REGNO (operands[1]));
  }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand4,
	operand5));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:276 */
extern rtx gen_peephole2_133 (rtx, rtx *);
rtx
gen_peephole2_133 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 285 "../../gcc/config/avr/avr.md"
{
    operands[4] = gen_rtx_REG (HImode, REGNO (operands[2]));
    operands[5] = gen_rtx_REG (HImode, REGNO (operands[3]));
  }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand4,
	operand5));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:293 */
rtx
gen_movsi (rtx operand0,
	rtx operand1)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#line 297 "../../gcc/config/avr/avr.md"

{
  /* One of the ops has to be in a register.  */
  if (!register_operand (operand0, SImode)
      && !(register_operand (operand1, SImode) || const0_rtx == operand1))
    {
      operands[1] = copy_to_mode_reg (SImode, operand1);
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:309 */
extern rtx gen_peephole2_135 (rtx, rtx *);
rtx
gen_peephole2_135 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[2] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 317 "../../gcc/config/avr/avr.md"
if (!avr_peep2_scratch_safe (operands[2]))
     FAIL;
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:343 */
rtx
gen_movsf (rtx operand0,
	rtx operand1)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#line 347 "../../gcc/config/avr/avr.md"

{
  /* One of the ops has to be in a register.  */
  if (!register_operand (operand1, SFmode)
      && !register_operand (operand0, SFmode))
    {
      operands[1] = copy_to_mode_reg (SFmode, operand1);
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:370 */
rtx
gen_movmemhi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#line 376 "../../gcc/config/avr/avr.md"
{
  int prob;
  HOST_WIDE_INT count;
  enum machine_mode mode;
  rtx label = gen_label_rtx ();
  rtx loop_reg;
  rtx jump;

  /* Copy pointers into new psuedos - they will be changed.  */
  rtx addr0 = copy_to_mode_reg (Pmode, XEXP (operands[0], 0));
  rtx addr1 = copy_to_mode_reg (Pmode, XEXP (operands[1], 0));

  /* Create rtx for tmp register - we use this as scratch.  */
  rtx tmp_reg_rtx  = gen_rtx_REG (QImode, TMP_REGNO);

  if (GET_CODE (operands[2]) != CONST_INT)
    FAIL;

  count = INTVAL (operands[2]);
  if (count <= 0)
    FAIL;

  /* Work out branch probability for latter use.  */
  prob = REG_BR_PROB_BASE - REG_BR_PROB_BASE / count;

  /* See if constant fit 8 bits.  */
  mode = (count < 0x100) ? QImode : HImode;
  /* Create loop counter register.  */
  loop_reg = copy_to_mode_reg (mode, gen_int_mode (count, mode));

  /* Now create RTL code for move loop.  */
  /* Label at top of loop.  */
  emit_label (label);

  /* Move one byte into scratch and inc pointer.  */
  emit_move_insn (tmp_reg_rtx, gen_rtx_MEM (QImode, addr1));
  emit_move_insn (addr1, gen_rtx_PLUS (Pmode, addr1, const1_rtx));

  /* Move to mem and inc pointer.  */
  emit_move_insn (gen_rtx_MEM (QImode, addr0), tmp_reg_rtx);
  emit_move_insn (addr0, gen_rtx_PLUS (Pmode, addr0, const1_rtx));

  /* Decrement count.  */
  emit_move_insn (loop_reg, gen_rtx_PLUS (mode, loop_reg, constm1_rtx));

  /* Compare with zero and jump if not equal. */
  emit_cmp_and_jump_insns (loop_reg, const0_rtx, NE, NULL_RTX, mode, 1,
                           label);
  /* Set jump probability based on loop count.  */
  jump = get_last_insn ();
  REG_NOTES (jump) = gen_rtx_EXPR_LIST (REG_BR_PROB,
                    GEN_INT (prob),
                    REG_NOTES (jump));
  DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
  }
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_rtx_USE (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:435 */
rtx
gen_setmemhi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[6];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#line 443 "../../gcc/config/avr/avr.md"
{
  rtx addr0;
  int cnt8;
  enum machine_mode mode;

  /* If value to set is not zero, use the library routine.  */
  if (operands[2] != const0_rtx)
    FAIL;

  if (GET_CODE (operands[1]) != CONST_INT)
    FAIL;

  cnt8 = byte_immediate_operand (operands[1], GET_MODE (operands[1]));
  mode = cnt8 ? QImode : HImode;
  operands[5] = gen_rtx_SCRATCH (mode);
  operands[1] = copy_to_mode_reg (mode,
                                  gen_int_mode (INTVAL (operands[1]), mode));
  addr0 = copy_to_mode_reg (Pmode, XEXP (operands[0], 0));
  operands[0] = gen_rtx_MEM (BLKmode, addr0);
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
    operand4 = operands[4];
    operand5 = operands[5];
  }
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand2),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_rtx_CLOBBER (VOIDmode,
	operand5))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:500 */
rtx
gen_strlenhi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[6];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#line 512 "../../gcc/config/avr/avr.md"
{
  rtx addr;
  if (! (GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) == 0))
    FAIL;
  addr = copy_to_mode_reg (Pmode, XEXP (operands[1],0));
  operands[1] = gen_rtx_MEM (BLKmode, addr); 
  operands[5] = addr;
  operands[4] = gen_reg_rtx (HImode);
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
    operand4 = operands[4];
    operand5 = operands[5];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand4,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (3,
		operand1,
		operand2,
		operand3),
	0)));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand4),
	gen_rtx_PLUS (HImode,
	copy_rtx (operand4),
	constm1_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	copy_rtx (operand4),
	operand5)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:552 */
rtx
gen_addhi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#line 557 "../../gcc/config/avr/avr.md"

{
  if (GET_CODE (operands[2]) == CONST_INT)
    {
      short tmp = INTVAL (operands[2]);
      operands[2] = GEN_INT(tmp);
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:845 */
rtx
gen_mulqi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#line 850 "../../gcc/config/avr/avr.md"
{
  if (!AVR_HAVE_MUL)
    {
      emit_insn (gen_mulqi3_call (operands[0], operands[1], operands[2]));
      DONE;
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (QImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:869 */
rtx
gen_mulqi3_call (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_MULT (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_hard_reg_clobber (QImode, 22))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (QImode,
	24)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:908 */
rtx
gen_mulhi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#line 913 "../../gcc/config/avr/avr.md"

{
  if (!AVR_HAVE_MUL)
    {
      emit_insn (gen_mulhi3_call (operands[0], operands[1], operands[2]));
      DONE;
    }
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:937 */
rtx
gen_mulhi3_call (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_MULT (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_hard_reg_clobber (HImode, 22),
		gen_hard_reg_clobber (QImode, 21))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (HImode,
	24)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:958 */
rtx
gen_mulsi3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_MULT (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (HImode, 30))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (SImode,
	22)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:985 */
rtx
gen_divmodqi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_DIV (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	25),
	gen_rtx_MOD (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_hard_reg_clobber (QImode, 22),
		gen_hard_reg_clobber (QImode, 23))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (QImode,
	24)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (QImode,
	25)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1007 */
rtx
gen_udivmodqi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_UDIV (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (QImode,
	25),
	gen_rtx_UMOD (QImode,
	gen_rtx_REG (QImode,
	24),
	gen_rtx_REG (QImode,
	22))),
		gen_hard_reg_clobber (QImode, 23))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (QImode,
	24)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (QImode,
	25)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1027 */
rtx
gen_divmodhi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	gen_rtx_DIV (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_MOD (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (QImode, 21))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (HImode,
	22)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (HImode,
	24)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1049 */
rtx
gen_udivmodhi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	22),
	gen_rtx_UDIV (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_UMOD (HImode,
	gen_rtx_REG (HImode,
	24),
	gen_rtx_REG (HImode,
	22))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (QImode, 21))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (HImode,
	22)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (HImode,
	24)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1071 */
rtx
gen_divmodsi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	gen_rtx_DIV (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_MOD (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (HImode, 30))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (SImode,
	18)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (SImode,
	22)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1093 */
rtx
gen_udivmodsi4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx _val = 0;
  start_sequence ();
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	operand2));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	18),
	gen_rtx_UDIV (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_UMOD (SImode,
	gen_rtx_REG (SImode,
	22),
	gen_rtx_REG (SImode,
	18))),
		gen_hard_reg_clobber (HImode, 26),
		gen_hard_reg_clobber (HImode, 30))));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_REG (SImode,
	18)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_REG (SImode,
	22)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1356 */
extern rtx gen_peephole2_152 (rtx, rtx *);
rtx
gen_peephole2_152 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1364 "../../gcc/config/avr/avr.md"
if (!avr_peep2_scratch_safe (operands[3]))
     FAIL;
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1377 */
extern rtx gen_peephole2_153 (rtx, rtx *);
rtx
gen_peephole2_153 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1385 "../../gcc/config/avr/avr.md"
if (!avr_peep2_scratch_safe (operands[3]))
     FAIL;
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1430 */
extern rtx gen_peephole2_154 (rtx, rtx *);
rtx
gen_peephole2_154 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1438 "../../gcc/config/avr/avr.md"
if (!avr_peep2_scratch_safe (operands[3]))
     FAIL;
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1451 */
extern rtx gen_peephole2_155 (rtx, rtx *);
rtx
gen_peephole2_155 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1459 "../../gcc/config/avr/avr.md"
if (!avr_peep2_scratch_safe (operands[3]))
     FAIL;
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1504 */
extern rtx gen_peephole2_156 (rtx, rtx *);
rtx
gen_peephole2_156 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1512 "../../gcc/config/avr/avr.md"
if (!avr_peep2_scratch_safe (operands[3]))
     FAIL;
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1525 */
extern rtx gen_peephole2_157 (rtx, rtx *);
rtx
gen_peephole2_157 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[3] = peep2_find_free_register (0, 0, "d", QImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();
#line 1533 "../../gcc/config/avr/avr.md"
if (!avr_peep2_scratch_safe (operands[3]))
     FAIL;
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1688 */
extern rtx gen_split_158 (rtx, rtx *);
rtx
gen_split_158 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 1696 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (QImode, HImode);
   unsigned int high_off = subreg_highpart_offset (QImode, HImode);
   
   operands[2] = simplify_gen_subreg (QImode, operands[0], HImode, low_off);
   operands[3] = simplify_gen_subreg (QImode, operands[0], HImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1703 */
extern rtx gen_split_159 (rtx, rtx *);
rtx
gen_split_159 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 1711 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (HImode, SImode);
   unsigned int high_off = subreg_highpart_offset (HImode, SImode);
   
   operands[2] = simplify_gen_subreg (HImode, operands[0], SImode, low_off);
   operands[3] = simplify_gen_subreg (HImode, operands[0], SImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1718 */
extern rtx gen_split_160 (rtx, rtx *);
rtx
gen_split_160 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 1726 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (HImode, SImode);
   unsigned int high_off = subreg_highpart_offset (HImode, SImode);
   
   operands[2] = simplify_gen_subreg (HImode, operands[0], SImode, low_off);
   operands[3] = simplify_gen_subreg (HImode, operands[0], SImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1733 */
extern rtx gen_split_161 (rtx, rtx *);
rtx
gen_split_161 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 1741 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (SImode, DImode);
   unsigned int high_off = subreg_highpart_offset (SImode, DImode);
   
   operands[2] = simplify_gen_subreg (SImode, operands[0], DImode, low_off);
   operands[3] = simplify_gen_subreg (SImode, operands[0], DImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1748 */
extern rtx gen_split_162 (rtx, rtx *);
rtx
gen_split_162 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 1756 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (SImode, DImode);
   unsigned int high_off = subreg_highpart_offset (SImode, DImode);
   
   operands[2] = simplify_gen_subreg (SImode, operands[0], DImode, low_off);
   operands[3] = simplify_gen_subreg (SImode, operands[0], DImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1763 */
extern rtx gen_split_163 (rtx, rtx *);
rtx
gen_split_163 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
#line 1771 "../../gcc/config/avr/avr.md"
unsigned int low_off = subreg_lowpart_offset (SImode, DImode);
   unsigned int high_off = subreg_highpart_offset (SImode, DImode);
   
   operands[2] = simplify_gen_subreg (SImode, operands[0], DImode, low_off);
   operands[3] = simplify_gen_subreg (SImode, operands[0], DImode, high_off);
  
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	const0_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:1966 */
rtx
gen_beq (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:1974 */
rtx
gen_bne (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:1982 */
rtx
gen_bge (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GE (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:1990 */
rtx
gen_bgeu (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GEU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:1998 */
rtx
gen_blt (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LT (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2006 */
rtx
gen_bltu (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LTU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2021 */
rtx
gen_ble (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LE (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2029 */
rtx
gen_bleu (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LEU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2037 */
rtx
gen_bgt (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GT (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2045 */
rtx
gen_bgtu (rtx operand0)
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GTU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ../../gcc/config/avr/avr.md:2119 */
extern rtx gen_peephole2_174 (rtx, rtx *);
rtx
gen_peephole2_174 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2131 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	gen_rtx_ZERO_EXTRACT (VOIDmode,
	operand0,
	const1_rtx,
	const_int_rtx[MAX_SAVED_CONST_INT + (7)]),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2133 */
extern rtx gen_peephole2_175 (rtx, rtx *);
rtx
gen_peephole2_175 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2145 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	gen_rtx_ZERO_EXTRACT (VOIDmode,
	operand0,
	const1_rtx,
	const_int_rtx[MAX_SAVED_CONST_INT + (7)]),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2147 */
extern rtx gen_peephole2_176 (rtx, rtx *);
rtx
gen_peephole2_176 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2157 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	gen_rtx_AND (HImode,
	operand0,
	GEN_INT (-32768L)),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2159 */
extern rtx gen_peephole2_177 (rtx, rtx *);
rtx
gen_peephole2_177 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2169 "../../gcc/config/avr/avr.md"

  operand0 = operands[0];
  operand1 = operands[1];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	gen_rtx_AND (HImode,
	operand0,
	GEN_INT (-32768L)),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2171 */
extern rtx gen_peephole2_178 (rtx, rtx *);
rtx
gen_peephole2_178 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2181 "../../gcc/config/avr/avr.md"
operands[2] = GEN_INT (-2147483647 - 1);
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	gen_rtx_AND (SImode,
	operand0,
	operand2),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2183 */
extern rtx gen_peephole2_179 (rtx, rtx *);
rtx
gen_peephole2_179 (rtx curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
#line 2193 "../../gcc/config/avr/avr.md"
operands[2] = GEN_INT (-2147483647 - 1);
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	gen_rtx_AND (SImode,
	operand0,
	operand2),
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2279 */
rtx
gen_call (rtx operand0,
	rtx operand1)
{
  return gen_rtx_CALL (VOIDmode,
	operand0,
	operand1);
}

/* ../../gcc/config/avr/avr.md:2288 */
rtx
gen_call_value (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_CALL (VOIDmode,
	operand1,
	operand2));
}

/* ../../gcc/config/avr/avr.md:2444 */
rtx
gen_casesi (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3,
	rtx operand4)
{
  rtx operand5;
  rtx operand6;
  rtx operand7 ATTRIBUTE_UNUSED;
  rtx operand8 ATTRIBUTE_UNUSED;
  rtx operand9 ATTRIBUTE_UNUSED;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[10];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
    operands[4] = operand4;
#line 2466 "../../gcc/config/avr/avr.md"

{
  operands[6] = gen_reg_rtx (HImode);
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
    operand4 = operands[4];
    operand5 = operands[5];
    operand6 = operands[6];
    operand7 = operands[7];
    operand8 = operands[8];
    operand9 = operands[9];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand6,
	gen_rtx_MINUS (HImode,
	gen_rtx_SUBREG (HImode,
	operand0,
	0),
	operand1)));
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	copy_rtx (operand6),
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode)))));
  emit_jump_insn (gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GTU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand4),
	pc_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand6),
	gen_rtx_PLUS (HImode,
	copy_rtx (operand6),
	gen_rtx_LABEL_REF (VOIDmode,
	operand3))));
  emit_jump_insn (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		copy_rtx (operand6)),
	1)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_LABEL_REF (VOIDmode,
	copy_rtx (operand3))),
		gen_rtx_CLOBBER (VOIDmode,
	copy_rtx (operand6)))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2838 */
rtx
gen_prologue (void)
{
  rtx _val = 0;
  start_sequence ();
  {
#line 2841 "../../gcc/config/avr/avr.md"

  {
    expand_prologue (); 
    DONE;
  }
  }
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc/config/avr/avr.md:2847 */
rtx
gen_epilogue (void)
{
  rtx _val = 0;
  start_sequence ();
  {
#line 2850 "../../gcc/config/avr/avr.md"

  {
    expand_epilogue (); 
    DONE;
  }
  }
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}



void
add_clobbers (rtx pattern ATTRIBUTE_UNUSED, int insn_code_number)
{
  switch (insn_code_number)
    {
    case 123:
      XVECEXP (pattern, 0, 3) = gen_hard_reg_clobber (QImode, 30);
      break;

    case 122:
      XVECEXP (pattern, 0, 4) = gen_hard_reg_clobber (HImode, 30);
      break;

    case 94:
    case 93:
    case 66:
    case 65:
    case 61:
    case 60:
    case 56:
    case 55:
    case 48:
    case 46:
    case 42:
      XVECEXP (pattern, 0, 1) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode));
      break;

    case 40:
    case 39:
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (HImode, 26);
      XVECEXP (pattern, 0, 3) = gen_hard_reg_clobber (HImode, 30);
      break;

    case 38:
    case 37:
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (HImode, 26);
      XVECEXP (pattern, 0, 3) = gen_hard_reg_clobber (QImode, 21);
      break;

    case 36:
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (QImode, 23);
      break;

    case 35:
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (QImode, 22);
      XVECEXP (pattern, 0, 3) = gen_hard_reg_clobber (QImode, 23);
      break;

    case 34:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (HImode, 26);
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (HImode, 30);
      break;

    case 33:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (HImode, 22);
      XVECEXP (pattern, 0, 2) = gen_hard_reg_clobber (QImode, 21);
      break;

    case 29:
      XVECEXP (pattern, 0, 1) = gen_hard_reg_clobber (QImode, 22);
      break;

    case 13:
      XVECEXP (pattern, 0, 3) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode));
      XVECEXP (pattern, 0, 4) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode));
      break;

    case 12:
      XVECEXP (pattern, 0, 3) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode));
      XVECEXP (pattern, 0, 4) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode));
      break;

    default:
      gcc_unreachable ();
    }
}


int
added_clobbers_hard_reg_p (int insn_code_number)
{
  switch (insn_code_number)
    {
    case 94:
    case 93:
    case 66:
    case 65:
    case 61:
    case 60:
    case 56:
    case 55:
    case 48:
    case 46:
    case 42:
    case 13:
    case 12:
      return 0;

    case 123:
    case 122:
    case 40:
    case 39:
    case 38:
    case 37:
    case 36:
    case 35:
    case 34:
    case 33:
    case 29:
      return 1;

    default:
      gcc_unreachable ();
    }
}
