/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "toplev.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

#ifdef ENABLE_CHECKING
  memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
  memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
#endif

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 187:
    case 186:
    case 185:
    case 184:
    case 183:
      for (i = XVECLEN (pat, 0) - 1; i >= 0; i--)
          ro[i] = *(ro_loc[i] = &XVECEXP (pat, 0, i));
      break;

    case 123:  /* epilogue_restores */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1));
      break;

    case 122:  /* call_prologue_saves */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 1));
      break;

    case 119:  /* pophi */
    case 118:  /* popqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 117:  /* *sbix_branch_tmp_bit7 */
    case 115:  /* *sbix_branch_bit7 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 116:  /* *sbix_branch_tmp */
    case 114:  /* *sbix_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 113:  /* *sbi */
    case 112:  /* *cbi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 110:  /* *tablejump */
    case 109:  /* *tablejump_enh */
    case 108:  /* *tablejump_lib */
    case 107:  /* *tablejump_rjmp */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 2), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 103:  /* call_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 101:  /* difficult_rvbranch */
    case 100:  /* rvbranch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 99:  /* difficult_branch */
    case 98:  /* branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 97:  /* *sbrx_and_branchsi */
    case 96:  /* *sbrx_and_branchhi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 95:  /* *sbrx_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 94:  /* cmpsi */
    case 93:  /* cmphi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 92:  /* *cmpqi_sign_extend */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 91:  /* cmpqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 102:  /* jump */
    case 90:  /* *negated_tstsi */
    case 88:  /* *negated_tsthi */
    case 86:  /* *negated_tstqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 84:  /* zero_extendsidi2 */
    case 83:  /* zero_extendhidi2 */
    case 82:  /* zero_extendqidi2 */
    case 81:  /* zero_extendhisi2 */
    case 80:  /* zero_extendqisi2 */
    case 79:  /* zero_extendqihi2 */
    case 78:  /* extendhisi2 */
    case 77:  /* extendqisi2 */
    case 76:  /* extendqihi2 */
    case 75:  /* one_cmplsi2 */
    case 74:  /* one_cmplhi2 */
    case 73:  /* one_cmplqi2 */
    case 72:  /* negsf2 */
    case 71:  /* negsi2 */
    case 70:  /* neghi2 */
    case 69:  /* negqi2 */
    case 68:  /* abssf2 */
    case 67:  /* absqi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 66:  /* *lshrsi3_const */
    case 65:  /* *lshrhi3_const */
    case 61:  /* *ashrsi3_const */
    case 60:  /* *ashrhi3_const */
    case 56:  /* *ashlsi3_const */
    case 55:  /* *ashlhi3_const */
    case 48:  /* *iorsi3_clobber */
    case 46:  /* *iorhi3_clobber */
    case 42:  /* andhi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 127:  /* return_from_naked_epilogue */
    case 126:  /* return_from_interrupt_epilogue */
    case 125:  /* return_from_epilogue */
    case 124:  /* return */
    case 121:  /* disable_interrupt */
    case 120:  /* enable_interrupt */
    case 111:  /* sez */
    case 105:  /* nop */
    case 40:  /* *udivmodsi4_call */
    case 39:  /* *divmodsi4_call */
    case 38:  /* *udivmodhi4_call */
    case 37:  /* *divmodhi4_call */
    case 36:  /* *udivmodqi4_call */
    case 35:  /* *divmodqi4_call */
    case 34:  /* *mulsi3_call */
    case 33:  /* *mulhi3_call */
    case 29:  /* *mulqi3_call */
      break;

    case 19:  /* *addhi3_sp_R_pc2 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 1));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 31:  /* umulqihi3 */
    case 30:  /* mulqihi3 */
    case 18:  /* *addhi3_zero_extend2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 27:  /* *subsi3_zero_extend */
    case 25:  /* *subhi3_zero_extend1 */
    case 17:  /* *addhi3_zero_extend1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 104:  /* call_value_insn */
    case 22:  /* *addsi3_zero_extend */
    case 16:  /* *addhi3_zero_extend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 64:  /* lshrsi3 */
    case 63:  /* lshrhi3 */
    case 62:  /* lshrqi3 */
    case 59:  /* ashrsi3 */
    case 58:  /* ashrhi3 */
    case 57:  /* ashrqi3 */
    case 54:  /* ashlsi3 */
    case 53:  /* ashlhi3 */
    case 52:  /* ashlqi3 */
    case 51:  /* xorsi3 */
    case 50:  /* xorhi3 */
    case 49:  /* xorqi3 */
    case 47:  /* iorsi3 */
    case 45:  /* iorhi3 */
    case 44:  /* iorqi3 */
    case 43:  /* andsi3 */
    case 41:  /* andqi3 */
    case 32:  /* *mulhi3_enh */
    case 28:  /* *mulqi3_enh */
    case 26:  /* subsi3 */
    case 24:  /* subhi3 */
    case 23:  /* subqi3 */
    case 21:  /* addsi3 */
    case 20:  /* *addhi3 */
    case 15:  /* addqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 14:  /* *strlenhi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 13:  /* *clrmemhi */
    case 12:  /* *clrmemqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 4), 0));
      break;

    case 9:  /* *reload_insi */
    case 7:  /* *reload_inhi */
    case 5:  /* *reload_inqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 11:  /* *movsf */
    case 10:  /* *movsi */
    case 8:  /* *movhi */
    case 6:  /* *movhi_sp */
    case 4:  /* *movqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 106:  /* indirect_jump */
    case 89:  /* tstsi */
    case 87:  /* tsthi */
    case 85:  /* tstqi */
    case 3:  /* *pushsf */
    case 2:  /* *pushsi */
    case 1:  /* *pushhi */
    case 0:  /* *pushqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    }
}
