/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "flags.h"
#include "ggc.h"
#include "rtl.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "function.h"
#include "regs.h"
#include "hard-reg-set.h"
#include "real.h"
#include "insn-config.h"

#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "toplev.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char * const output_0[] = {
  "push %0",
  "push __zero_reg__",
};

static const char * const output_1[] = {
  "push %B0\n\tpush %A0",
  "push __zero_reg__\n\tpush __zero_reg__",
};

static const char * const output_2[] = {
  "push %D0\n\tpush %C0\n\tpush %B0\n\tpush %A0",
  "push __zero_reg__\n\tpush __zero_reg__\n\tpush __zero_reg__\n\tpush __zero_reg__",
};

static const char *
output_4 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 177 "../../gcc/config/avr/avr.md"
 return output_movqi (insn, operands, NULL);
}

static const char *
output_6 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 228 "../../gcc/config/avr/avr.md"
 return output_movhi (insn, operands, NULL);
}

static const char *
output_7 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 249 "../../gcc/config/avr/avr.md"
 return output_reload_inhi (insn, operands, NULL);
}

static const char *
output_8 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 258 "../../gcc/config/avr/avr.md"
 return output_movhi (insn, operands, NULL);
}

static const char *
output_9 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 326 "../../gcc/config/avr/avr.md"
 return output_reload_insisf (insn, operands, NULL);
}

static const char *
output_10 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 336 "../../gcc/config/avr/avr.md"
 return output_movsisf (insn, operands, NULL);
}

static const char *
output_11 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 362 "../../gcc/config/avr/avr.md"
 return output_movsisf (insn, operands, NULL);
}

static const char *
output_13 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 486 "../../gcc/config/avr/avr.md"
{
     if (which_alternative==0)
       return (AS2 (st,%a0+,__zero_reg__) CR_TAB
	       AS2 (sbiw,%A1,1) CR_TAB
	       AS1 (brne,.-6));
     else
       return (AS2 (st,%a0+,__zero_reg__) CR_TAB
	       AS2 (subi,%A1,1) CR_TAB
	       AS2 (sbci,%B1,0) CR_TAB
	       AS1 (brne,.-8));
}
}

static const char * const output_15[] = {
  "add %0,%2",
  "subi %0,lo8(-(%2))",
  "inc %0",
  "dec %0",
};

static const char *
output_19 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 606 "../../gcc/config/avr/avr.md"
{
      if (CONST_INT_P (operands[0]))
        {
	  switch(INTVAL (operands[0]))
	    {
	    case -6: 
	      return "rcall ." CR_TAB 
	             "rcall ." CR_TAB 
		     "rcall .";
	    case -5: 
	      return "rcall ." CR_TAB 
	             "rcall ." CR_TAB 
		     "push __tmp_reg__";
	    case -4: 
	      return "rcall ." CR_TAB 
	             "rcall .";
	    case -3: 
	      return "rcall ." CR_TAB 
	             "push __tmp_reg__";
	    case -2: 
	      return "rcall .";
	    case -1: 
	      return "push __tmp_reg__";
	    case 0: 
	      return "";
	    case 1: 
	      return "pop __tmp_reg__";
	    case 2: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__";
	    case 3: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__";
	    case 4: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__";
	    case 5: 
	      return "pop __tmp_reg__" CR_TAB 
	             "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__" CR_TAB 
		     "pop __tmp_reg__";
	    }
        }
      return "bug";
    }
}

static const char * const output_20[] = {
  "add %A0,%A2\n\tadc %B0,%B2",
  "adiw %A0,%2",
  "sbiw %A0,%n2",
  "subi %A0,lo8(-(%2))\n\tsbci %B0,hi8(-(%2))",
  "sec\n\tadc %A0,__zero_reg__\n\tadc %B0,__zero_reg__",
  "sec\n\tsbc %A0,__zero_reg__\n\tsbc %B0,__zero_reg__",
};

static const char * const output_21[] = {
  "add %A0,%A2\n\tadc %B0,%B2\n\tadc %C0,%C2\n\tadc %D0,%D2",
  "adiw %0,%2\n\tadc %C0,__zero_reg__\n\tadc %D0,__zero_reg__",
  "sbiw %0,%n2\n\tsbc %C0,__zero_reg__\n\tsbc %D0,__zero_reg__",
  "subi %0,lo8(-(%2))\n\tsbci %B0,hi8(-(%2))\n\tsbci %C0,hlo8(-(%2))\n\tsbci %D0,hhi8(-(%2))",
  "sec\n\tadc %A0,__zero_reg__\n\tadc %B0,__zero_reg__\n\tadc %C0,__zero_reg__\n\tadc %D0,__zero_reg__",
  "sec\n\tsbc %A0,__zero_reg__\n\tsbc %B0,__zero_reg__\n\tsbc %C0,__zero_reg__\n\tsbc %D0,__zero_reg__",
};

static const char * const output_23[] = {
  "sub %0,%2",
  "subi %0,lo8(%2)",
};

static const char * const output_24[] = {
  "sub %A0,%A2\n\tsbc %B0,%B2",
  "subi %A0,lo8(%2)\n\tsbci %B0,hi8(%2)",
};

static const char * const output_26[] = {
  "sub %0,%2\n\tsbc %B0,%B2\n\tsbc %C0,%C2\n\tsbc %D0,%D2",
  "subi %A0,lo8(%2)\n\tsbci %B0,hi8(%2)\n\tsbci %C0,hlo8(%2)\n\tsbci %D0,hhi8(%2)",
};

static const char * const output_41[] = {
  "and %0,%2",
  "andi %0,lo8(%2)",
};

static const char *
output_42 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1135 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
    return (AS2 (and,%A0,%A2) CR_TAB
	    AS2 (and,%B0,%B2));
  else if (which_alternative==1)
    {
      if (GET_CODE (operands[2]) == CONST_INT)
        {
	  int mask = INTVAL (operands[2]);
	  if ((mask & 0xff) != 0xff)
	    output_asm_insn (AS2 (andi,%A0,lo8(%2)), operands);
	  if ((mask & 0xff00) != 0xff00)
	    output_asm_insn (AS2 (andi,%B0,hi8(%2)), operands);
	  return "";
        }
        return (AS2 (andi,%A0,lo8(%2)) CR_TAB
	        AS2 (andi,%B0,hi8(%2)));
     }
  return (AS2 (ldi,%3,lo8(%2)) CR_TAB
          AS2 (and,%A0,%3)     CR_TAB
          AS1 (clr,%B0));
}
}

static const char *
output_43 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1165 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
    return (AS2 (and, %0,%2)   CR_TAB
	    AS2 (and, %B0,%B2) CR_TAB
	    AS2 (and, %C0,%C2) CR_TAB
	    AS2 (and, %D0,%D2));
  else if (which_alternative==1)
    {
      if (GET_CODE (operands[2]) == CONST_INT)
        {
	  HOST_WIDE_INT mask = INTVAL (operands[2]);
	  if ((mask & 0xff) != 0xff)
	    output_asm_insn (AS2 (andi,%A0,lo8(%2)), operands);
	  if ((mask & 0xff00) != 0xff00)
	    output_asm_insn (AS2 (andi,%B0,hi8(%2)), operands);
	  if ((mask & 0xff0000L) != 0xff0000L)
	    output_asm_insn (AS2 (andi,%C0,hlo8(%2)), operands);
	  if ((mask & 0xff000000L) != 0xff000000L)
	    output_asm_insn (AS2 (andi,%D0,hhi8(%2)), operands);
	  return "";
        }
      return (AS2 (andi, %A0,lo8(%2))  CR_TAB
              AS2 (andi, %B0,hi8(%2)) CR_TAB
	      AS2 (andi, %C0,hlo8(%2)) CR_TAB
	      AS2 (andi, %D0,hhi8(%2)));
    }
  return "bug";
}
}

static const char * const output_44[] = {
  "or %0,%2",
  "ori %0,lo8(%2)",
};

static const char *
output_45 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1215 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
    return (AS2 (or,%A0,%A2) CR_TAB
	    AS2 (or,%B0,%B2));
  if (GET_CODE (operands[2]) == CONST_INT)
     {
	int mask = INTVAL (operands[2]);
	if (mask & 0xff)
	  output_asm_insn (AS2 (ori,%A0,lo8(%2)), operands);
	if (mask & 0xff00)
	  output_asm_insn (AS2 (ori,%B0,hi8(%2)), operands);
	return "";
      }
   return (AS2 (ori,%0,lo8(%2)) CR_TAB
	   AS2 (ori,%B0,hi8(%2)));
}
}

static const char * const output_46[] = {
  "ldi %3,lo8(%2)\n\tor %A0,%3",
  "ldi %3,lo8(%2)\n\tor %A0,%3\n\tldi %3,hi8(%2)\n\tor %B0,%3",
};

static const char *
output_47 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1251 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
    return (AS2 (or, %0,%2)   CR_TAB
	    AS2 (or, %B0,%B2) CR_TAB
	    AS2 (or, %C0,%C2) CR_TAB
	    AS2 (or, %D0,%D2));
  if (GET_CODE (operands[2]) == CONST_INT)
     {
	HOST_WIDE_INT mask = INTVAL (operands[2]);
	if (mask & 0xff)
	  output_asm_insn (AS2 (ori,%A0,lo8(%2)), operands);
	if (mask & 0xff00)
	  output_asm_insn (AS2 (ori,%B0,hi8(%2)), operands);
	if (mask & 0xff0000L)
	  output_asm_insn (AS2 (ori,%C0,hlo8(%2)), operands);
	if (mask & 0xff000000L)
	  output_asm_insn (AS2 (ori,%D0,hhi8(%2)), operands);
	return "";
      }
  return (AS2 (ori, %A0,lo8(%2))  CR_TAB
	  AS2 (ori, %B0,hi8(%2)) CR_TAB
	  AS2 (ori, %C0,hlo8(%2)) CR_TAB
	  AS2 (ori, %D0,hhi8(%2)));
}
}

static const char * const output_48[] = {
  "ldi %3,lo8(%2)\n\tor %A0,%3",
  "ldi %3,lo8(%2)\n\tor %A0,%3\n\tldi %3,hi8(%2)\n\tor %B0,%3\n\tldi %3,hlo8(%2)\n\tor %C0,%3\n\tldi %3,hhi8(%2)\n\tor %D0,%3",
};

static const char *
output_52 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1332 "../../gcc/config/avr/avr.md"
 return ashlqi3_out (insn, operands, NULL);
}

static const char *
output_53 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1341 "../../gcc/config/avr/avr.md"
 return ashlhi3_out (insn, operands, NULL);
}

static const char *
output_54 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1350 "../../gcc/config/avr/avr.md"
 return ashlsi3_out (insn, operands, NULL);
}

static const char *
output_55 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1373 "../../gcc/config/avr/avr.md"
 return ashlhi3_out (insn, operands, NULL);
}

static const char *
output_56 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1394 "../../gcc/config/avr/avr.md"
 return ashlsi3_out (insn, operands, NULL);
}

static const char *
output_57 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1406 "../../gcc/config/avr/avr.md"
 return ashrqi3_out (insn, operands, NULL);
}

static const char *
output_58 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1415 "../../gcc/config/avr/avr.md"
 return ashrhi3_out (insn, operands, NULL);
}

static const char *
output_59 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1424 "../../gcc/config/avr/avr.md"
 return ashrsi3_out (insn, operands, NULL);
}

static const char *
output_60 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1447 "../../gcc/config/avr/avr.md"
 return ashrhi3_out (insn, operands, NULL);
}

static const char *
output_61 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1468 "../../gcc/config/avr/avr.md"
 return ashrsi3_out (insn, operands, NULL);
}

static const char *
output_62 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1480 "../../gcc/config/avr/avr.md"
 return lshrqi3_out (insn, operands, NULL);
}

static const char *
output_63 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1489 "../../gcc/config/avr/avr.md"
 return lshrhi3_out (insn, operands, NULL);
}

static const char *
output_64 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1498 "../../gcc/config/avr/avr.md"
 return lshrsi3_out (insn, operands, NULL);
}

static const char *
output_65 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1521 "../../gcc/config/avr/avr.md"
 return lshrhi3_out (insn, operands, NULL);
}

static const char *
output_66 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1542 "../../gcc/config/avr/avr.md"
 return lshrsi3_out (insn, operands, NULL);
}

static const char * const output_68[] = {
  "andi %D0,0x7f",
  "clt\n\tbld %D0,7",
};

static const char * const output_70[] = {
  "com %B0\n\tneg %A0\n\tsbci %B0,lo8(-1)",
  "com %B0\n\tneg %A0\n\tsbc %B0,__zero_reg__\n\tinc %B0",
  "clr %A0\n\tclr %B0\n\tsub %A0,%A1\n\tsbc %B0,%B1",
};

static const char * const output_71[] = {
  "com %D0\n\tcom %C0\n\tcom %B0\n\tneg %A0\n\tsbci %B0,lo8(-1)\n\tsbci %C0,lo8(-1)\n\tsbci %D0,lo8(-1)",
  "com %D0\n\tcom %C0\n\tcom %B0\n\tcom %A0\n\tadc %A0,__zero_reg__\n\tadc %B0,__zero_reg__\n\tadc %C0,__zero_reg__\n\tadc %D0,__zero_reg__",
  "clr %A0\n\tclr %B0\n\t{clr %C0\n\tclr %D0|movw %C0,%A0}\n\tsub %A0,%A1\n\tsbc %B0,%B1\n\tsbc %C0,%C1\n\tsbc %D0,%D1",
};

static const char * const output_72[] = {
  "subi %D0,0x80",
  "bst %D0,7\n\tcom %D0\n\tbld %D0,7\n\tcom %D0",
};

static const char * const output_76[] = {
  "clr %B0\n\tsbrc %0,7\n\tcom %B0",
  "mov %A0,%A1\n\tclr %B0\n\tsbrc %A0,7\n\tcom %B0",
};

static const char * const output_77[] = {
  "clr %B0\n\tsbrc %A0,7\n\tcom %B0\n\tmov %C0,%B0\n\tmov %D0,%B0",
  "mov %A0,%A1\n\tclr %B0\n\tsbrc %A0,7\n\tcom %B0\n\tmov %C0,%B0\n\tmov %D0,%B0",
};

static const char * const output_78[] = {
  "clr %C0\n\tsbrc %B0,7\n\tcom %C0\n\tmov %D0,%C0",
  "{mov %A0,%A1\n\tmov %B0,%B1|movw %A0,%A1}\n\tclr %C0\n\tsbrc %B0,7\n\tcom %C0\n\tmov %D0,%C0",
};

static const char *
output_87 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1801 "../../gcc/config/avr/avr.md"
 return out_tsthi (insn,NULL);
}

static const char *
output_89 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1818 "../../gcc/config/avr/avr.md"
 return out_tstsi (insn,NULL);
}

static const char * const output_91[] = {
  "cp %0,%1",
  "cpi %0,lo8(%1)",
};

static const char *
output_93 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1861 "../../gcc/config/avr/avr.md"
{
  switch (which_alternative)
    {
    case 0:
      return (AS2 (cp,%A0,%A1) CR_TAB
              AS2 (cpc,%B0,%B1));
    case 1:
      if (reg_unused_after (insn, operands[0])
          && INTVAL (operands[1]) >= 0 && INTVAL (operands[1]) <= 63
          && test_hard_reg_class (ADDW_REGS, operands[0]))
        return AS2 (sbiw,%0,%1);
       else
        return (AS2 (cpi,%0,%1) CR_TAB
                AS2 (cpc,%B0,__zero_reg__));
    case 2:
      if (reg_unused_after (insn, operands[0]))
        return (AS2 (subi,%0,lo8(%1))  CR_TAB
                AS2 (sbci,%B0,hi8(%1)));
      else
        return (AS2 (ldi, %2,hi8(%1))  CR_TAB
	        AS2 (cpi, %A0,lo8(%1)) CR_TAB
	        AS2 (cpc, %B0,%2));
   case 3:
      return (AS2 (ldi, %2,lo8(%1))  CR_TAB
	      AS2 (cp, %A0,%2) CR_TAB
	      AS2 (cpc, %B0,__zero_reg__));

   case 4:
      return (AS2 (ldi, %2,lo8(%1))  CR_TAB
              AS2 (cp, %A0,%2)       CR_TAB
              AS2 (ldi, %2,hi8(%1)) CR_TAB
	      AS2 (cpc, %B0,%2));
    }
  return "bug";
}
}

static const char *
output_94 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 1906 "../../gcc/config/avr/avr.md"
{
  switch (which_alternative)
    {
    case 0:
      return (AS2 (cp,%A0,%A1) CR_TAB
              AS2 (cpc,%B0,%B1) CR_TAB
	      AS2 (cpc,%C0,%C1) CR_TAB
	      AS2 (cpc,%D0,%D1));
    case 1:
      if (reg_unused_after (insn, operands[0])
          && INTVAL (operands[1]) >= 0 && INTVAL (operands[1]) <= 63
          && test_hard_reg_class (ADDW_REGS, operands[0]))
        return (AS2 (sbiw,%0,%1) CR_TAB
                AS2 (cpc,%C0,__zero_reg__) CR_TAB
                AS2 (cpc,%D0,__zero_reg__));
      else
        return (AS2 (cpi,%A0,lo8(%1))  CR_TAB
                AS2 (cpc,%B0,__zero_reg__) CR_TAB
                AS2 (cpc,%C0,__zero_reg__) CR_TAB
                AS2 (cpc,%D0,__zero_reg__));
    case 2:
      if (reg_unused_after (insn, operands[0]))
        return (AS2 (subi,%A0,lo8(%1))  CR_TAB
                AS2 (sbci,%B0,hi8(%1))  CR_TAB
                AS2 (sbci,%C0,hlo8(%1))  CR_TAB
                AS2 (sbci,%D0,hhi8(%1)));
      else
       return (AS2 (cpi, %A0,lo8(%1))   CR_TAB
	       AS2 (ldi, %2,hi8(%1))  CR_TAB
	       AS2 (cpc, %B0,%2)       CR_TAB
	       AS2 (ldi, %2,hlo8(%1))  CR_TAB
	       AS2 (cpc, %C0,%2)       CR_TAB
	       AS2 (ldi, %2,hhi8(%1)) CR_TAB
	       AS2 (cpc, %D0,%2));
    case 3:
        return (AS2 (ldi,%2,lo8(%1))        CR_TAB
                AS2 (cp,%A0,%2)            CR_TAB
                AS2 (cpc,%B0,__zero_reg__) CR_TAB
                AS2 (cpc,%C0,__zero_reg__) CR_TAB
                AS2 (cpc,%D0,__zero_reg__));
    case 4:
       return (AS2 (ldi, %2,lo8(%1))   CR_TAB
               AS2 (cp, %A0,%2)        CR_TAB
	       AS2 (ldi, %2,hi8(%1))  CR_TAB
	       AS2 (cpc, %B0,%2)       CR_TAB
	       AS2 (ldi, %2,hlo8(%1))  CR_TAB
	       AS2 (cpc, %C0,%2)       CR_TAB
	       AS2 (ldi, %2,hhi8(%1)) CR_TAB
	       AS2 (cpc, %D0,%2));
    }
  return "bug";
}
}

static const char *
output_95 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2066 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_96 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2087 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_97 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2108 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_98 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2208 "../../gcc/config/avr/avr.md"

   return ret_cond_branch (operands[1], avr_jump_mode (operands[0],insn), 0);
}

static const char *
output_99 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2221 "../../gcc/config/avr/avr.md"

   return ret_cond_branch (operands[1], avr_jump_mode (operands[0],insn), 0);
}

static const char *
output_100 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2236 "../../gcc/config/avr/avr.md"

   return ret_cond_branch (operands[1], avr_jump_mode (operands[0], insn), 1);
}

static const char *
output_101 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2249 "../../gcc/config/avr/avr.md"

   return ret_cond_branch (operands[1], avr_jump_mode (operands[0], insn), 1);
}

static const char *
output_102 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2261 "../../gcc/config/avr/avr.md"
{
  if (AVR_MEGA && get_attr_length (insn) != 1)
    return AS1 (jmp,%0);
  return AS1 (rjmp,%0);
}
}

static const char *
output_103 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2302 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
     return "icall";
  else if (which_alternative==1)
    {
      if (AVR_HAVE_MOVW)
	return (AS2 (movw, r30, %0) CR_TAB
		"icall");
      else
	return (AS2 (mov, r30, %A0) CR_TAB
		AS2 (mov, r31, %B0) CR_TAB
		"icall");
    }
  else if (which_alternative==2)
    return AS1(%~call,%c0);
  return (AS2 (ldi,r30,lo8(%0)) CR_TAB
          AS2 (ldi,r31,hi8(%0)) CR_TAB
          "icall");
}
}

static const char *
output_104 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2339 "../../gcc/config/avr/avr.md"
{
  if (which_alternative==0)
     return "icall";
  else if (which_alternative==1)
    {
      if (AVR_HAVE_MOVW)
	return (AS2 (movw, r30, %1) CR_TAB
		"icall");
      else
	return (AS2 (mov, r30, %A1) CR_TAB
		AS2 (mov, r31, %B1) CR_TAB
		"icall");
    }
  else if (which_alternative==2)
    return AS1(%~call,%c1);
  return (AS2 (ldi, r30, lo8(%1)) CR_TAB
          AS2 (ldi, r31, hi8(%1)) CR_TAB
          "icall");
}
}

static const char * const output_106[] = {
  "ijmp",
  "push %A0\n\tpush %B0\n\tret",
};

static const char * const output_107[] = {
  "ijmp",
  "push %A0\n\tpush %B0\n\tret",
};

static const char *
output_112 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2489 "../../gcc/config/avr/avr.md"
{
  operands[2] = GEN_INT (exact_log2 (~INTVAL (operands[1]) & 0xff));
  return AS2 (cbi,%0-0x20,%2);
}
}

static const char *
output_113 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2501 "../../gcc/config/avr/avr.md"
{
  operands[2] = GEN_INT (exact_log2 (INTVAL (operands[1]) & 0xff));
  return AS2 (sbi,%0-0x20,%2);
}
}

static const char *
output_114 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2521 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_115 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2541 "../../gcc/config/avr/avr.md"
{
  operands[3] = operands[2];
  operands[2] = GEN_INT (7);
  return avr_out_sbxx_branch (insn, operands);
}
}

static const char *
output_116 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2568 "../../gcc/config/avr/avr.md"
 return avr_out_sbxx_branch (insn, operands);
}

static const char *
output_117 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2587 "../../gcc/config/avr/avr.md"
{
  operands[3] = operands[2];
  operands[2] = GEN_INT (7);
  return avr_out_sbxx_branch (insn, operands);
}
}

static const char *
output_183 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2617 "../../gcc/config/avr/avr.md"

{
  CC_STATUS_INIT;
  if (test_hard_reg_class (ADDW_REGS, operands[0]))
    output_asm_insn (AS2 (sbiw,%0,1) CR_TAB
		     AS2 (sbc,%C0,__zero_reg__) CR_TAB
		     AS2 (sbc,%D0,__zero_reg__) "\n", operands);
  else
    output_asm_insn (AS2 (subi,%A0,1) CR_TAB
		     AS2 (sbc,%B0,__zero_reg__) CR_TAB
		     AS2 (sbc,%C0,__zero_reg__) CR_TAB
		     AS2 (sbc,%D0,__zero_reg__) "\n", operands);
  switch (avr_jump_mode (operands[2],insn))
  {
    case 1:
      return AS1 (brcc,%2);
    case 2:
      return (AS1 (brcs,.+2) CR_TAB
              AS1 (rjmp,%2));
  }
  return (AS1 (brcs,.+4) CR_TAB
          AS1 (jmp,%2));
}
}

static const char *
output_184 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2655 "../../gcc/config/avr/avr.md"

{
  CC_STATUS_INIT;
  if (test_hard_reg_class (ADDW_REGS, operands[0]))
    output_asm_insn (AS2 (sbiw,%0,1), operands);
  else
    output_asm_insn (AS2 (subi,%A0,1) CR_TAB
		     AS2 (sbc,%B0,__zero_reg__) "\n", operands);
  switch (avr_jump_mode (operands[2],insn))
  {
    case 1:
      return AS1 (brcc,%2);
    case 2:
      return (AS1 (brcs,.+2) CR_TAB
              AS1 (rjmp,%2));
  }
  return (AS1 (brcs,.+4) CR_TAB
          AS1 (jmp,%2));
}
}

static const char *
output_185 (rtx *operands ATTRIBUTE_UNUSED, rtx insn ATTRIBUTE_UNUSED)
{
#line 2687 "../../gcc/config/avr/avr.md"

{
  CC_STATUS_INIT;
  cc_status.value1 = operands[0];
  cc_status.flags |= CC_OVERFLOW_UNUSABLE;
  output_asm_insn (AS2 (subi,%A0,1), operands);
  switch (avr_jump_mode (operands[1],insn))
  {
    case 1:
      return AS1 (brcc,%1);
    case 2:
      return (AS1 (brcs,.+2) CR_TAB
              AS1 (rjmp,%1));
  }
  return (AS1 (brcs,.+4) CR_TAB
          AS1 (jmp,%1));
}
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    reg_or_0_operand,
    "r,L",
    QImode,
    0,
    1
  },
  {
    reg_or_0_operand,
    "r,L",
    HImode,
    0,
    1
  },
  {
    reg_or_0_operand,
    "r,L",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    SFmode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "=r,d,Qm,r,q,r,*r",
    QImode,
    0,
    1
  },
  {
    general_operand,
    "r,i,rL,Qm,r,q,i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=l",
    QImode,
    0,
    1
  },
  {
    immediate_operand,
    "i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=&d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=q,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r,q",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "i",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=&d",
    QImode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,m,d,*r,q,r",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "r,m,rL,i,i,r,q",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    immediate_operand,
    "i",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=&d",
    QImode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,Qm,!d,r",
    SImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,Qm,rL,i,i",
    SImode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,Qm,!d,r",
    SFmode,
    0,
    1
  },
  {
    general_operand,
    "r,G,Qm,r,F,F",
    SFmode,
    0,
    1
  },
  {
    register_operand,
    "e",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "=0",
    HImode,
    0,
    0
  },
  {
    scratch_operand,
    "=&1",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "e,e",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "!w,d",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "n,n",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "=0,0",
    HImode,
    0,
    0
  },
  {
    scratch_operand,
    "=&1,&1",
    HImode,
    0,
    0
  },
  {
    register_operand,
    "=e",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "i",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d,r,r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0,0,0",
    QImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i,P,N",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    avr_sp_immediate_operand,
    "R",
    HImode,
    0,
    1
  },
  {
    stack_register_operand,
    "=q",
    HImode,
    0,
    1
  },
  {
    stack_register_operand,
    "q",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,!w,!w,d,r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0,0,0,0,0",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,I,J,i,P,N",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,!w,!w,d,r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0,0,0,0,0",
    SImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,I,J,i,P,N",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0,0",
    QImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,0",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,0",
    SImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=&r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    QImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0,0",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i,M",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r,d",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    SImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r,d",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "M,i",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "=&d,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "%0,0",
    SImode,
    0,
    1
  },
  {
    immediate_operand,
    "M,i",
    SImode,
    0,
    1
  },
  {
    scratch_operand,
    "=&d,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "%0",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r,!d,r,r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,0,0,0,0,0",
    QImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,P,K,n,n,Qm",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r,r,r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,0,r,0,0,0",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,P,O,K,n,Qm",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r,r,r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,0,r,0,0,0",
    SImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,P,O,K,n,Qm",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,r,0,0",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "L,P,O,K,n",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,X,X,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r,r,r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,r,0",
    SImode,
    0,
    1
  },
  {
    const_int_operand,
    "L,P,O,n",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,X,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "=r,r,r,r,r,r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,0,0,0,0",
    QImode,
    0,
    1
  },
  {
    general_operand,
    "r,L,P,K,n,Qm",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "0",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=d,r",
    SFmode,
    0,
    1
  },
  {
    register_operand,
    "0,0",
    SFmode,
    0,
    1
  },
  {
    register_operand,
    "=!d,r,&r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=!d,r,&r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,0,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "0,*r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,*r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r,&r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "0,*r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "!w,r",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r,d",
    QImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,i",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "d",
    QImode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "r,d,d,r,r",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,M,i,M,i",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,&d,&d,&d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "r,d,d,r,r",
    SImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "r,M,i,M,i",
    SImode,
    0,
    1
  },
  {
    scratch_operand,
    "=X,X,&d,&d,&d",
    QImode,
    0,
    0
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    register_operand,
    "r",
    QImode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    register_operand,
    "r",
    HImode,
    0,
    1
  },
  {
    single_one_operand,
    "n",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    register_operand,
    "r",
    SImode,
    0,
    1
  },
  {
    single_one_operand,
    "n",
    SImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    simple_comparison_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    difficult_comparison_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    nonmemory_operand,
    "!z,*r,s,n",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "X,X,X,X",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "=r,r,r,r",
    VOIDmode,
    0,
    1
  },
  {
    nonmemory_operand,
    "!z,*r,s,n",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "X,X,X,X",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "!z,*r",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    register_operand,
    "z",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    low_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    single_zero_operand,
    "n",
    QImode,
    0,
    1
  },
  {
    low_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    single_one_operand,
    "n",
    QImode,
    0,
    1
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    low_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    gelt_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    low_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    eqne_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    high_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    gelt_operator,
    "",
    VOIDmode,
    0,
    0
  },
  {
    high_io_address_operand,
    "n",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "",
    QImode,
    0,
    1
  },
  {
    general_operand,
    "",
    QImode,
    0,
    1
  },
  {
    l_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "",
    HImode,
    0,
    1
  },
  {
    l_register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    even_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    even_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    odd_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    odd_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    even_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    even_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    nonimmediate_operand,
    "",
    SImode,
    0,
    1
  },
  {
    general_operand,
    "",
    SImode,
    0,
    1
  },
  {
    l_register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    SImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    SFmode,
    0,
    1
  },
  {
    general_operand,
    "",
    SFmode,
    0,
    1
  },
  {
    memory_operand,
    "",
    BLKmode,
    0,
    1
  },
  {
    memory_operand,
    "",
    BLKmode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    HImode,
    0,
    1
  },
  {
    memory_operand,
    "",
    BLKmode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    VOIDmode,
    0,
    1
  },
  {
    const_int_operand,
    "n",
    HImode,
    0,
    1
  },
  {
    scratch_operand,
    "",
    HImode,
    0,
    0
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    memory_operand,
    "",
    BLKmode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    QImode,
    0,
    1
  },
  {
    immediate_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    nonmemory_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    const_int_operand,
    "",
    QImode,
    0,
    1
  },
  {
    scratch_operand,
    "d",
    QImode,
    0,
    0
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    DImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    call_insn_operand,
    "",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    VOIDmode,
    0,
    1
  },
  {
    call_insn_operand,
    "",
    HImode,
    0,
    1
  },
  {
    general_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    HImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    0,
    "",
    VOIDmode,
    0,
    0
  },
  {
    scratch_operand,
    "",
    QImode,
    0,
    0
  },
  {
    d_register_operand,
    "",
    SImode,
    0,
    1
  },
  {
    d_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    d_register_operand,
    "",
    HImode,
    0,
    1
  },
  {
    d_register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    register_operand,
    "",
    QImode,
    0,
    1
  },
  {
    0,
    "",
    VOIDmode,
    0,
    1
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data insn_data[] = 
{
  /* ../../gcc/config/avr/avr.md:115 */
  {
    "*pushqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_0 },
#else
    { 0, output_0, 0 },
#endif
    0,
    &operand_data[1],
    1,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:125 */
  {
    "*pushhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_1 },
#else
    { 0, output_1, 0 },
#endif
    0,
    &operand_data[2],
    1,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:134 */
  {
    "*pushsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_2 },
#else
    { 0, output_2, 0 },
#endif
    0,
    &operand_data[3],
    1,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:143 */
  {
    "*pushsf",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "push %D0\n\
	push %C0\n\
	push %B0\n\
	push %A0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[4],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:172 */
  {
    "*movqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_4 },
#else
    { 0, 0, output_4 },
#endif
    0,
    &operand_data[5],
    2,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:184 */
  {
    "*reload_inqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldi %2,lo8(%1)\n\
	mov %0,%2",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[7],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:223 */
  {
    "*movhi_sp",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_6 },
#else
    { 0, 0, output_6 },
#endif
    0,
    &operand_data[10],
    2,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:244 */
  {
    "*reload_inhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_7 },
#else
    { 0, 0, output_7 },
#endif
    0,
    &operand_data[12],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:253 */
  {
    "*movhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_8 },
#else
    { 0, 0, output_8 },
#endif
    0,
    &operand_data[15],
    2,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:321 */
  {
    "*reload_insi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_9 },
#else
    { 0, 0, output_9 },
#endif
    0,
    &operand_data[17],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:331 */
  {
    "*movsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_10 },
#else
    { 0, 0, output_10 },
#endif
    0,
    &operand_data[20],
    2,
    0,
    6,
    3
  },
  /* ../../gcc/config/avr/avr.md:357 */
  {
    "*movsf",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_11 },
#else
    { 0, 0, output_11 },
#endif
    0,
    &operand_data[22],
    2,
    0,
    6,
    3
  },
  /* ../../gcc/config/avr/avr.md:464 */
  {
    "*clrmemqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "st %a0+,__zero_reg__\n\
        dec %1\n\
	brne .-6",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[24],
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:478 */
  {
    "*clrmemhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_13 },
#else
    { 0, 0, output_13 },
#endif
    0,
    &operand_data[29],
    5,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:522 */
  {
    "*strlenhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ld __tmp_reg__,%a0+\n\
	tst __tmp_reg__\n\
	brne .-6",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[34],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:538 */
  {
    "addqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_15 },
#else
    { 0, output_15, 0 },
#endif
    (insn_gen_fn) gen_addqi3,
    &operand_data[37],
    3,
    0,
    4,
    2
  },
  /* ../../gcc/config/avr/avr.md:567 */
  {
    "*addhi3_zero_extend",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "add %A0,%1\n\
	adc %B0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[40],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:578 */
  {
    "*addhi3_zero_extend1",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "add %A0,%2\n\
	adc %B0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[43],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:589 */
  {
    "*addhi3_zero_extend2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "add %0,%2\n\
	mov %B0,__zero_reg__\n\
	adc %B0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[46],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:601 */
  {
    "*addhi3_sp_R_pc2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_19 },
#else
    { 0, 0, output_19 },
#endif
    0,
    &operand_data[49],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:738 */
  {
    "*addhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_20 },
#else
    { 0, output_20, 0 },
#endif
    0,
    &operand_data[52],
    3,
    0,
    6,
    2
  },
  /* ../../gcc/config/avr/avr.md:754 */
  {
    "addsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_21 },
#else
    { 0, output_21, 0 },
#endif
    (insn_gen_fn) gen_addsi3,
    &operand_data[55],
    3,
    0,
    6,
    2
  },
  /* ../../gcc/config/avr/avr.md:770 */
  {
    "*addsi3_zero_extend",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "add %A0,%1\n\
	adc %B0,__zero_reg__\n\
	adc %C0,__zero_reg__\n\
	adc %D0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[58],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:785 */
  {
    "subqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_23 },
#else
    { 0, output_23, 0 },
#endif
    (insn_gen_fn) gen_subqi3,
    &operand_data[61],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:796 */
  {
    "subhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_24 },
#else
    { 0, output_24, 0 },
#endif
    (insn_gen_fn) gen_subhi3,
    &operand_data[64],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:807 */
  {
    "*subhi3_zero_extend1",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %A0,%2\n\
	sbc %B0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[67],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:818 */
  {
    "subsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_26 },
#else
    { 0, output_26, 0 },
#endif
    (insn_gen_fn) gen_subsi3,
    &operand_data[70],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:829 */
  {
    "*subsi3_zero_extend",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %A0,%2\n\
	sbc %B0,__zero_reg__\n\
	sbc %C0,__zero_reg__\n\
	sbc %D0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[73],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:858 */
  {
    "*mulqi3_enh",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul %1,%2\n\
	mov %0,r0\n\
	clr r1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[76],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:878 */
  {
    "*mulqi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __mulqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:886 */
  {
    "mulqihi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "muls %1,%2\n\
	movw %0,r0\n\
	clr r1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_mulqihi3,
    &operand_data[79],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:897 */
  {
    "umulqihi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul %1,%2\n\
	movw %0,r0\n\
	clr r1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_umulqihi3,
    &operand_data[82],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:922 */
  {
    "*mulhi3_enh",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul %A1,%A2\n\
	movw %0,r0\n\
	mul %A1,%B2\n\
	add %B0,r0\n\
	mul %B1,%A2\n\
	add %B0,r0\n\
	clr r1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[85],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:947 */
  {
    "*mulhi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __mulhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:968 */
  {
    "*mulsi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __mulsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:997 */
  {
    "*divmodqi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __divmodqi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1018 */
  {
    "*udivmodqi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __udivmodqi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1039 */
  {
    "*divmodhi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __divmodhi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1061 */
  {
    "*udivmodhi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __udivmodhi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1083 */
  {
    "*divmodsi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __divmodsi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1105 */
  {
    "*udivmodsi4_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "%~call __udivmodsi4",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:1118 */
  {
    "andqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_41 },
#else
    { 0, output_41, 0 },
#endif
    (insn_gen_fn) gen_andqi3,
    &operand_data[88],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1129 */
  {
    "andhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_42 },
#else
    { 0, 0, output_42 },
#endif
    (insn_gen_fn) gen_andhi3,
    &operand_data[91],
    4,
    0,
    3,
    3
  },
  /* ../../gcc/config/avr/avr.md:1160 */
  {
    "andsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_43 },
#else
    { 0, 0, output_43 },
#endif
    (insn_gen_fn) gen_andsi3,
    &operand_data[95],
    3,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:1199 */
  {
    "iorqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_44 },
#else
    { 0, output_44, 0 },
#endif
    (insn_gen_fn) gen_iorqi3,
    &operand_data[88],
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1210 */
  {
    "iorhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_45 },
#else
    { 0, 0, output_45 },
#endif
    (insn_gen_fn) gen_iorhi3,
    &operand_data[98],
    3,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:1234 */
  {
    "*iorhi3_clobber",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_46 },
#else
    { 0, output_46, 0 },
#endif
    0,
    &operand_data[101],
    4,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1246 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_47 },
#else
    { 0, 0, output_47 },
#endif
    (insn_gen_fn) gen_iorsi3,
    &operand_data[95],
    3,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:1278 */
  {
    "*iorsi3_clobber",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_48 },
#else
    { 0, output_48, 0 },
#endif
    0,
    &operand_data[105],
    4,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1293 */
  {
    "xorqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "eor %0,%2",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_xorqi3,
    &operand_data[109],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1302 */
  {
    "xorhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "eor %0,%2\n\
	eor %B0,%B2",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_xorhi3,
    &operand_data[112],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1312 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "eor %0,%2\n\
	eor %B0,%B2\n\
	eor %C0,%C2\n\
	eor %D0,%D2",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_xorsi3,
    &operand_data[115],
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1327 */
  {
    "ashlqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_52 },
#else
    { 0, 0, output_52 },
#endif
    (insn_gen_fn) gen_ashlqi3,
    &operand_data[118],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1336 */
  {
    "ashlhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_53 },
#else
    { 0, 0, output_53 },
#endif
    (insn_gen_fn) gen_ashlhi3,
    &operand_data[121],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1345 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_54 },
#else
    { 0, 0, output_54 },
#endif
    (insn_gen_fn) gen_ashlsi3,
    &operand_data[124],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1367 */
  {
    "*ashlhi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_55 },
#else
    { 0, 0, output_55 },
#endif
    0,
    &operand_data[127],
    4,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:1388 */
  {
    "*ashlsi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_56 },
#else
    { 0, 0, output_56 },
#endif
    0,
    &operand_data[131],
    4,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:1401 */
  {
    "ashrqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_57 },
#else
    { 0, 0, output_57 },
#endif
    (insn_gen_fn) gen_ashrqi3,
    &operand_data[135],
    3,
    0,
    6,
    3
  },
  /* ../../gcc/config/avr/avr.md:1410 */
  {
    "ashrhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_58 },
#else
    { 0, 0, output_58 },
#endif
    (insn_gen_fn) gen_ashrhi3,
    &operand_data[121],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1419 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_59 },
#else
    { 0, 0, output_59 },
#endif
    (insn_gen_fn) gen_ashrsi3,
    &operand_data[124],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1441 */
  {
    "*ashrhi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_60 },
#else
    { 0, 0, output_60 },
#endif
    0,
    &operand_data[127],
    4,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:1462 */
  {
    "*ashrsi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_61 },
#else
    { 0, 0, output_61 },
#endif
    0,
    &operand_data[131],
    4,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:1475 */
  {
    "lshrqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_62 },
#else
    { 0, 0, output_62 },
#endif
    (insn_gen_fn) gen_lshrqi3,
    &operand_data[118],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1484 */
  {
    "lshrhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_63 },
#else
    { 0, 0, output_63 },
#endif
    (insn_gen_fn) gen_lshrhi3,
    &operand_data[121],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1493 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_64 },
#else
    { 0, 0, output_64 },
#endif
    (insn_gen_fn) gen_lshrsi3,
    &operand_data[124],
    3,
    0,
    7,
    3
  },
  /* ../../gcc/config/avr/avr.md:1515 */
  {
    "*lshrhi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_65 },
#else
    { 0, 0, output_65 },
#endif
    0,
    &operand_data[127],
    4,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:1536 */
  {
    "*lshrsi3_const",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_66 },
#else
    { 0, 0, output_66 },
#endif
    0,
    &operand_data[131],
    4,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:1549 */
  {
    "absqi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sbrc %0,7\n\
	neg %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_absqi2,
    &operand_data[138],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1559 */
  {
    "abssf2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_68 },
#else
    { 0, output_68, 0 },
#endif
    (insn_gen_fn) gen_abssf2,
    &operand_data[140],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1572 */
  {
    "negqi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_negqi2,
    &operand_data[138],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1580 */
  {
    "neghi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_70 },
#else
    { 0, output_70, 0 },
#endif
    (insn_gen_fn) gen_neghi2,
    &operand_data[142],
    2,
    0,
    3,
    2
  },
  /* ../../gcc/config/avr/avr.md:1591 */
  {
    "negsi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_71 },
#else
    { 0, output_71, 0 },
#endif
    (insn_gen_fn) gen_negsi2,
    &operand_data[144],
    2,
    0,
    3,
    2
  },
  /* ../../gcc/config/avr/avr.md:1607 */
  {
    "negsf2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_72 },
#else
    { 0, output_72, 0 },
#endif
    (insn_gen_fn) gen_negsf2,
    &operand_data[140],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1620 */
  {
    "one_cmplqi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "com %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_one_cmplqi2,
    &operand_data[138],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1628 */
  {
    "one_cmplhi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "com %0\n\
	com %B0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_one_cmplhi2,
    &operand_data[67],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1637 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "com %0\n\
	com %B0\n\
	com %C0\n\
	com %D0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_one_cmplsi2,
    &operand_data[73],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1651 */
  {
    "extendqihi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_76 },
#else
    { 0, output_76, 0 },
#endif
    (insn_gen_fn) gen_extendqihi2,
    &operand_data[146],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1661 */
  {
    "extendqisi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_77 },
#else
    { 0, output_77, 0 },
#endif
    (insn_gen_fn) gen_extendqisi2,
    &operand_data[148],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1671 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_78 },
#else
    { 0, output_78, 0 },
#endif
    (insn_gen_fn) gen_extendhisi2,
    &operand_data[150],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1688 */
  {
    "zero_extendqihi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendqihi2,
    &operand_data[40],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1703 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendqisi2,
    &operand_data[58],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1718 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendhisi2,
    &operand_data[152],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1733 */
  {
    "zero_extendqidi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendqidi2,
    &operand_data[154],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1748 */
  {
    "zero_extendhidi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendhidi2,
    &operand_data[156],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1763 */
  {
    "zero_extendsidi2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_zero_extendsidi2,
    &operand_data[158],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1781 */
  {
    "tstqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "tst %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_tstqi,
    &operand_data[25],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1789 */
  {
    "*negated_tstqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cp __zero_reg__,%0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[25],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1797 */
  {
    "tsthi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_87 },
#else
    { 0, 0, output_87 },
#endif
    (insn_gen_fn) gen_tsthi,
    &operand_data[160],
    1,
    0,
    2,
    3
  },
  /* ../../gcc/config/avr/avr.md:1805 */
  {
    "*negated_tsthi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cp __zero_reg__,%A0\n\
	cpc __zero_reg__,%B0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[86],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1814 */
  {
    "tstsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_89 },
#else
    { 0, 0, output_89 },
#endif
    (insn_gen_fn) gen_tstsi,
    &operand_data[117],
    1,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:1822 */
  {
    "*negated_tstsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cp __zero_reg__,%A0\n\
	cpc __zero_reg__,%B0\n\
	cpc __zero_reg__,%C0\n\
	cpc __zero_reg__,%D0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[117],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1834 */
  {
    "cmpqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_91 },
#else
    { 0, output_91, 0 },
#endif
    (insn_gen_fn) gen_cmpqi,
    &operand_data[161],
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:1845 */
  {
    "*cmpqi_sign_extend",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cpi %0,lo8(%1)",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[163],
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:1855 */
  {
    "cmphi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_93 },
#else
    { 0, 0, output_93 },
#endif
    (insn_gen_fn) gen_cmphi,
    &operand_data[165],
    3,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:1900 */
  {
    "cmpsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_94 },
#else
    { 0, 0, output_94 },
#endif
    (insn_gen_fn) gen_cmpsi,
    &operand_data[168],
    3,
    0,
    5,
    3
  },
  /* ../../gcc/config/avr/avr.md:2054 */
  {
    "*sbrx_branch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_95 },
#else
    { 0, 0, output_95 },
#endif
    0,
    &operand_data[171],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2076 */
  {
    "*sbrx_and_branchhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_96 },
#else
    { 0, 0, output_96 },
#endif
    0,
    &operand_data[175],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2097 */
  {
    "*sbrx_and_branchsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_97 },
#else
    { 0, 0, output_97 },
#endif
    0,
    &operand_data[179],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2200 */
  {
    "branch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_98 },
#else
    { 0, 0, output_98 },
#endif
    (insn_gen_fn) gen_branch,
    &operand_data[182],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2213 */
  {
    "difficult_branch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_99 },
#else
    { 0, 0, output_99 },
#endif
    (insn_gen_fn) gen_difficult_branch,
    &operand_data[184],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2228 */
  {
    "rvbranch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_100 },
#else
    { 0, 0, output_100 },
#endif
    (insn_gen_fn) gen_rvbranch,
    &operand_data[182],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2241 */
  {
    "difficult_rvbranch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_101 },
#else
    { 0, 0, output_101 },
#endif
    (insn_gen_fn) gen_difficult_rvbranch,
    &operand_data[184],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2257 */
  {
    "jump",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_102 },
#else
    { 0, 0, output_102 },
#endif
    (insn_gen_fn) gen_jump,
    &operand_data[174],
    1,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2296 */
  {
    "call_insn",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_103 },
#else
    { 0, 0, output_103 },
#endif
    (insn_gen_fn) gen_call_insn,
    &operand_data[186],
    2,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:2332 */
  {
    "call_value_insn",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_104 },
#else
    { 0, 0, output_104 },
#endif
    (insn_gen_fn) gen_call_value_insn,
    &operand_data[188],
    3,
    0,
    4,
    3
  },
  /* ../../gcc/config/avr/avr.md:2369 */
  {
    "nop",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "nop",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_nop,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2377 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_106 },
#else
    { 0, output_106, 0 },
#endif
    (insn_gen_fn) gen_indirect_jump,
    &operand_data[191],
    1,
    0,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:2389 */
  {
    "*tablejump_rjmp",
#if HAVE_DESIGNATED_INITIALIZERS
    { .multi = output_107 },
#else
    { 0, output_107, 0 },
#endif
    0,
    &operand_data[191],
    2,
    1,
    2,
    2
  },
  /* ../../gcc/config/avr/avr.md:2402 */
  {
    "*tablejump_lib",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "jmp __tablejump2__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[193],
    2,
    1,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2412 */
  {
    "*tablejump_enh",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "lsl r30\n\
	rol r31\n\
	lpm __tmp_reg__,Z+\n\
	lpm r31,Z\n\
	mov r30,__tmp_reg__\n\
	ijmp",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[193],
    2,
    1,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2427 */
  {
    "*tablejump",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "lsl r30\n\
	rol r31\n\
	lpm\n\
	inc r30\n\
	push r0\n\
	lpm\n\
	push r0\n\
	ret",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[193],
    2,
    1,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2475 */
  {
    "sez",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sez",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_sez,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2484 */
  {
    "*cbi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_112 },
#else
    { 0, 0, output_112 },
#endif
    0,
    &operand_data[195],
    2,
    1,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2496 */
  {
    "*sbi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_113 },
#else
    { 0, 0, output_113 },
#endif
    0,
    &operand_data[197],
    2,
    1,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2509 */
  {
    "*sbix_branch",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_114 },
#else
    { 0, 0, output_114 },
#endif
    0,
    &operand_data[199],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2532 */
  {
    "*sbix_branch_bit7",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_115 },
#else
    { 0, 0, output_115 },
#endif
    0,
    &operand_data[203],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2556 */
  {
    "*sbix_branch_tmp",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_116 },
#else
    { 0, 0, output_116 },
#endif
    0,
    &operand_data[206],
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2578 */
  {
    "*sbix_branch_tmp_bit7",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_117 },
#else
    { 0, 0, output_117 },
#endif
    0,
    &operand_data[210],
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/avr/avr.md:2728 */
  {
    "popqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "pop %0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_popqi,
    &operand_data[76],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2736 */
  {
    "pophi",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "pop %A0\n\tpop %B0",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_pophi,
    &operand_data[12],
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/avr/avr.md:2745 */
  {
    "enable_interrupt",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "sei",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_enable_interrupt,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2754 */
  {
    "disable_interrupt",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cli",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_disable_interrupt,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2763 */
  {
    "call_prologue_saves",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldi r30,pm_lo8(1f)\n\
	ldi r31,pm_hi8(1f)\n\
	%~jmp __prologue_saves__+((18 - %0) * 2)\n\
1:",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_call_prologue_saves,
    &operand_data[213],
    2,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2784 */
  {
    "epilogue_restores",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldi r30, lo8(%0)\n\
	%~jmp __epilogue_restores__ + ((18 - %0) * 2)",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_epilogue_restores,
    &operand_data[213],
    1,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2802 */
  {
    "return",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ret",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_return,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2809 */
  {
    "return_from_epilogue",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "ret",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_return_from_epilogue,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2819 */
  {
    "return_from_interrupt_epilogue",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "reti",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_return_from_interrupt_epilogue,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2829 */
  {
    "return_from_naked_epilogue",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    (insn_gen_fn) gen_return_from_naked_epilogue,
    &operand_data[0],
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:162 */
  {
    "movqi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movqi,
    &operand_data[215],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:194 */
  {
    "movqi+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[217],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:209 */
  {
    "movhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movhi,
    &operand_data[220],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:232 */
  {
    "movhi+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[222],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:262 */
  {
    "movhi+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[225],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:276 */
  {
    "movsi-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[227],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:293 */
  {
    "movsi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movsi,
    &operand_data[231],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:309 */
  {
    "movsi+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[233],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:343 */
  {
    "movsf",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movsf,
    &operand_data[236],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:370 */
  {
    "movmemhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_movmemhi,
    &operand_data[238],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:435 */
  {
    "setmemhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_setmemhi,
    &operand_data[242],
    5,
    1,
    1,
    0
  },
  /* ../../gcc/config/avr/avr.md:500 */
  {
    "strlenhi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_strlenhi,
    &operand_data[247],
    4,
    5,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:552 */
  {
    "addhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_addhi3,
    &operand_data[251],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:845 */
  {
    "mulqi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulqi3,
    &operand_data[254],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:869 */
  {
    "mulqi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulqi3_call,
    &operand_data[254],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:908 */
  {
    "mulhi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulhi3,
    &operand_data[257],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:937 */
  {
    "mulhi3_call",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulhi3_call,
    &operand_data[257],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:958 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_mulsi3,
    &operand_data[260],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:985 */
  {
    "divmodqi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_divmodqi4,
    &operand_data[263],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1007 */
  {
    "udivmodqi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_udivmodqi4,
    &operand_data[263],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1027 */
  {
    "divmodhi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_divmodhi4,
    &operand_data[267],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1049 */
  {
    "udivmodhi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_udivmodhi4,
    &operand_data[267],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1071 */
  {
    "divmodsi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_divmodsi4,
    &operand_data[271],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1093 */
  {
    "udivmodsi4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_udivmodsi4,
    &operand_data[271],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1356 */
  {
    "udivmodsi4+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[275],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1377 */
  {
    "udivmodsi4+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[279],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1430 */
  {
    "udivmodsi4+3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[275],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1451 */
  {
    "udivmodsi4+4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[279],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1504 */
  {
    "udivmodsi4+5",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[275],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1525 */
  {
    "udivmodsi4+6",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[279],
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1688 */
  {
    "beq-6",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[283],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1703 */
  {
    "beq-5",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[262],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1718 */
  {
    "beq-4",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[274],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1733 */
  {
    "beq-3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[285],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1748 */
  {
    "beq-2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[287],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1763 */
  {
    "beq-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[289],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1966 */
  {
    "beq",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_beq,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1974 */
  {
    "bne",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bne,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1982 */
  {
    "bge",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bge,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1990 */
  {
    "bgeu",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bgeu,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:1998 */
  {
    "blt",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_blt,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2006 */
  {
    "bltu",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bltu,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2021 */
  {
    "ble",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_ble,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2029 */
  {
    "bleu",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bleu,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2037 */
  {
    "bgt",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bgt,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2045 */
  {
    "bgtu",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_bgtu,
    &operand_data[174],
    1,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2119 */
  {
    "bgtu+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[291],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2133 */
  {
    "bgtu+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[291],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2147 */
  {
    "bgtu+3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[293],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2159 */
  {
    "call-3",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[293],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2171 */
  {
    "call-2",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[295],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2183 */
  {
    "call-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    0,
    &operand_data[295],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2279 */
  {
    "call",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_call,
    &operand_data[297],
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2288 */
  {
    "call_value",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_call_value,
    &operand_data[299],
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2444 */
  {
    "casesi",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_casesi,
    &operand_data[302],
    10,
    7,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2603 */
  {
    "casesi+1",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_183 },
#else
    { 0, 0, output_183 },
#endif
    0,
    &operand_data[312],
    3,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2641 */
  {
    "casesi+2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_184 },
#else
    { 0, 0, output_184 },
#endif
    0,
    &operand_data[315],
    3,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2675 */
  {
    "casesi+3",
#if HAVE_DESIGNATED_INITIALIZERS
    { .function = output_185 },
#else
    { 0, 0, output_185 },
#endif
    0,
    &operand_data[313],
    2,
    0,
    0,
    3
  },
  /* ../../gcc/config/avr/avr.md:2705 */
  {
    "prologue-2",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cpse %0,__zero_reg__",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[291],
    2,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2714 */
  {
    "prologue-1",
#if HAVE_DESIGNATED_INITIALIZERS
    { .single =
#else
    {
#endif
    "cpse %0,%1",
#if HAVE_DESIGNATED_INITIALIZERS
    },
#else
    0, 0 },
#endif
    0,
    &operand_data[318],
    3,
    0,
    0,
    1
  },
  /* ../../gcc/config/avr/avr.md:2838 */
  {
    "prologue",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_prologue,
    &operand_data[0],
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/avr/avr.md:2847 */
  {
    "epilogue",
#if HAVE_DESIGNATED_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    (insn_gen_fn) gen_epilogue,
    &operand_data[0],
    0,
    0,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
